import { Base, Point, Type, EventArgs, INotifyPropertyChanged, IEnumerable, IList, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { EventProxy } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { PieChartStyleInfo } from "./PieChartStyleInfo";
import { BrushCollection } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PieChartVisualData } from "./PieChartVisualData";
import { Style } from "igniteui-react-core";
import { Control } from "igniteui-react-core";
import { Line } from "igniteui-react-core";
import { LabelsPosition } from "./LabelsPosition";
import { List$1 } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { LeaderLineType } from "./LeaderLineType";
import { ILegendOwner } from "igniteui-react-core";
import { ILegendSeries } from "igniteui-react-core";
import { ILegendTemplateProvider } from "igniteui-react-core";
import { FastItemsSource } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { OthersCategoryType } from "./OthersCategoryType";
import { IndexCollection } from "./IndexCollection";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { IChartLegend } from "igniteui-react-core";
import { SweepDirection } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { SliceSelectionMode } from "./SliceSelectionMode";
import { ObjectCollection } from "igniteui-react-core";
import { BindingFormatter } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { SelectedItemChangingEventArgs } from "./SelectedItemChangingEventArgs";
import { SelectedItemsChangingEventArgs } from "./SelectedItemsChangingEventArgs";
import { SelectedItemChangedEventArgs } from "./SelectedItemChangedEventArgs";
import { SelectedItemsChangedEventArgs } from "./SelectedItemsChangedEventArgs";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { PieSliceVisualData } from "./PieSliceVisualData";
import { MouseEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PieChartViewManager extends Base {
    static $t: Type;
    n: DomRenderer;
    protected p: DomWrapper;
    protected s: DomWrapper;
    protected r: DomWrapper;
    protected q: DomWrapper;
    private k;
    private j;
    private l;
    protected ap: Rect;
    e: RenderingContext;
    g: RenderingContext;
    f: RenderingContext;
    h: RenderingContext;
    private a;
    constructor(a: PieChartBaseView);
    aa(): void;
    ad(a: number, b: number): void;
    ae(): void;
    ab(): void;
    z(): void;
    w(a: number, b: number): void;
    ao(): Rect;
    d(): FontInfo;
    an(): Point;
    ah(a: () => void): void;
    b(): PieChartStyleInfo;
    ai(a: Path): void;
    c: EventProxy;
    ac(a: any): void;
    v(a: DomWrapper): void;
    af(a: boolean): void;
    t(): any;
    x(a: PieChartVisualData): void;
    private _toolTipObject;
    private u;
    private i;
    ak(a: any): void;
    aj(pos_: Point, context_: PieSliceDataContext): void;
    y(a: PieSliceDataContext): void;
    al(style_: Style): Brush;
    am(style_: Style): Brush;
    m(style_: Style): number;
    ag(): void;
}
/**
 * @hidden
 */
export declare class LabelClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    slice: Slice;
    readonly item: any;
    allowSliceClick: boolean;
    private c;
}
/**
 * @hidden
 */
export declare class SliceClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    slice: Slice;
    isSelected: boolean;
    private d;
    isExploded: boolean;
    private c;
    readonly isOthersSlice: boolean;
    readonly index: number;
    readonly dataContext: any;
    private _originalEvent;
    originalEvent: any;
}
/**
 * @hidden
 */
export declare class PieLabel extends Control {
    static $t: Type;
    constructor();
    ah: Slice;
    ao: Rect;
    ai: number;
    aj: any;
    ap: Line;
    aq: Path;
    ag: LabelsPosition;
    ak(a: PieChartBaseView): void;
    al(): void;
    am(): void;
    an(): void;
}
/**
 * @hidden
 */
export declare abstract class PieChartBase extends Control implements INotifyPropertyChanged, ILegendOwner, ILegendSeries, ILegendTemplateProvider {
    static $t: Type;
    az(): PieChartBaseView;
    fu(a: PieChartBaseView): void;
    a0: PieChartBaseView;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    private br;
    private bu;
    private bt;
    private bv;
    private bs;
    private by;
    private bx;
    private bw;
    private readonly a4;
    private readonly cf;
    private readonly ch;
    private readonly cg;
    private readonly ci;
    private c5;
    bd: FastItemsSource;
    private bh;
    bm: IFastItemColumn$1<number>;
    c7: number;
    cz: number;
    c4: number;
    cc: List$1<number>;
    cb: List$1<number>;
    ca: List$1<any>;
    cp: number;
    b9: List$1<UIElement>;
    readonly cm: number;
    a3: PieChartSliceSelector;
    private _xsr;
    private readonly XSRP;
    readonly dn: string;
    itemsSource: IEnumerable;
    static readonly gq: DependencyProperty;
    cv: number;
    e4: string;
    dx: string;
    ec: string;
    private bf;
    bi: IFastItemColumn$1<any>;
    private bg;
    bj: IFastItemColumn$1<any>;
    aw: LabelsPosition;
    hu: Brush;
    ht: Brush;
    h6: Visibility;
    h2: Style;
    ax: LeaderLineType;
    cx: number;
    da: any;
    cy: number;
    ay: OthersCategoryType;
    ej: string;
    cq: number;
    readonly cl: number;
    c1: number;
    readonly co: number;
    b0: boolean;
    bz: boolean;
    explodedSlices: IndexCollection;
    private ar;
    legend: IChartLegend;
    cw: number;
    c3: number;
    hv: SweepDirection;
    selectedSlices: IndexCollection;
    private as;
    h3: Style;
    h4: Style;
    h5: Style;
    ak: BrushCollection;
    al: BrushCollection;
    dt: string;
    ag: any[];
    en: string;
    aj: any[];
    d9: string;
    ah: any[];
    ee: string;
    ai: any[];
    legendItemTemplate: DataTemplate;
    legendItemBadgeTemplate: DataTemplate;
    static readonly g0: DependencyProperty;
    gi: DataTemplate;
    b5: boolean;
    protected b2(): boolean;
    protected b3(): boolean;
    a1: (obj: any) => string;
    a2: (obj: any) => string;
    private ck;
    c0: number;
    private cj;
    cn: number;
    bb: SliceSelectionMode;
    selectedItem: any;
    static readonly hl: DependencyProperty;
    private _selectedItems;
    selectedItems: ObjectCollection;
    labelClick: (sender: any, e: LabelClickEventArgs) => void;
    fm(a: any, b: LabelClickEventArgs): void;
    selectedItemChanging: (sender: any, e: SelectedItemChangingEventArgs) => void;
    fo(a: any, b: SelectedItemChangingEventArgs): void;
    selectedItemsChanging: (sender: any, e: SelectedItemsChangingEventArgs) => void;
    fr(a: any, b: SelectedItemsChangingEventArgs): void;
    selectedItemChanged: (sender: any, e: SelectedItemChangedEventArgs) => void;
    fn(a: any, b: SelectedItemChangedEventArgs): void;
    selectedItemsChanged: (sender: any, e: SelectedItemsChangedEventArgs) => void;
    fp(a: any, b: SelectedItemsChangedEventArgs): void;
    sliceClick: (sender: any, e: SliceClickEventArgs) => void;
    ft(a: any, b: SliceClickEventArgs): void;
    bo: Pool$1<Slice>;
    bn: Pool$1<PieLabel>;
    e8(a: Slice, b: boolean): void;
    f8(a: Slice, b: boolean): void;
    f9(a: Slice): void;
    c8(a: Slice): any;
    h0(a: Slice, b: LabelsPosition): Rect;
    b1(a: PieLabel, b: Point): boolean;
    static c2(a: number): number;
    private b4;
    private static cr;
    static ge(a: List$1<PieLabel>): void;
    f6(a: List$1<PieLabel>): void;
    protected e6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    f2(): void;
    fv(): void;
    fx(): void;
    private et;
    fw(): void;
    h1: Rect;
    f5(): void;
    f3(): void;
    private static cs;
    private static hw;
    private static ct;
    private static hx;
    f4(): void;
    bc(): PieChartVisualData;
    di(): string;
    protected bk(a: string): IFastItemColumn$1<number>;
    protected bl(a: string): IFastItemColumn$1<any>;
    am: BindingFormatter;
    ap: BindingFormatter;
    an: BindingFormatter;
    ao: BindingFormatter;
    protected fy(a: any, b: string, c: any, d: any): void;
    protected f7(a: NotifyCollectionChangedEventArgs): void;
    protected fq(a: NotifyCollectionChangedEventArgs): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected f0(a: string, b: any, c: any): void;
    private gh;
    private gg;
    gc(a: Slice, b: MouseEventArgs): void;
    gd(a: Slice, b: MouseEventArgs, c: boolean): void;
    gb(a: Point): void;
    b6(a: Slice, b: MouseEventArgs): boolean;
    fa(a: any, b: any): void;
    fd(a: any, b: any, c: boolean): void;
    fc(a: any, b: any): void;
    fb(a: any, b: MouseEventArgs): void;
    fs(): void;
    provideContainer(a: any): void;
    fk(a: number, b: number): void;
    notifyContainerResized(): void;
    hz(): Rect;
    hy(): Point;
    destroy(): void;
    e9(): void;
    private db;
    ez: string;
    readonly container: ILegendOwner;
    readonly isStacked: boolean;
    readonly isVertical: boolean;
    readonly hasMarkers: boolean;
    readonly isUsableInLegend: boolean;
    readonly hasSubItems: boolean;
    cu(a: Slice): number;
    fi(source_: any, a: number, b: any, c: any): void;
    fe(source_: any): void;
    private b7;
    static b8(a: any, b: any): boolean;
    fg(source_: any, a: number, b: any): void;
    fh(source_: any, a: number, b: any): void;
    ga(source_: any): void;
    f1(): void;
    gf(): void;
    be(): FontInfo;
    resolveLegendIndex(): number;
    forSubItems(a: (arg1: any) => void): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartSliceSelector extends Base {
    static $t: Type;
    private a;
    constructor(a: PieChartBase);
    d(a: Slice): boolean;
    c(a: Slice): boolean;
    h(a: Slice): any;
    f(a: any, b: boolean): boolean;
    e(a: any): boolean;
    g(a: any): boolean;
    b(a: any): boolean;
    k(a: Slice): void;
    i(a: Slice): void;
    j(a: Slice): void;
}
/**
 * @hidden
 */
export declare class PieSliceOthersContext extends Base {
    static $t: Type;
    private _data;
    data: IList;
    private _slice;
    slice: Slice;
}
/**
 * @hidden
 */
export declare class Slice extends ContentControl {
    static $t: Type;
    ak(): SliceView;
    bl(a: SliceView): void;
    al: SliceView;
    constructor();
    a3: number;
    ax: number;
    a1: number;
    a0: number;
    static readonly bv: DependencyProperty;
    isSelected: boolean;
    static readonly bt: DependencyProperty;
    isExploded: boolean;
    static readonly bu: DependencyProperty;
    isOthersSlice: boolean;
    b7: Point;
    b5: Point;
    a2: number;
    ay: number;
    a5: number;
    b2: Brush;
    static readonly bp: DependencyProperty;
    a4: number;
    b8: Rect;
    ai: PieChartBase;
    aj: PieLabel;
    bf: string;
    b9: Rect;
    b3: Point;
    aq: boolean;
    au: boolean;
    av: boolean;
    ac(): void;
    az(): number;
    private cb;
    b6(): Point;
    private an;
    aw: boolean;
    bk(): void;
    ap(a: Point): boolean;
    private ao;
    private ca;
    am(): PieSliceVisualData;
    private static b4;
    b0: Brush;
    b1: Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartBaseView extends Base {
    static $t: Type;
    constructor(a: PieChartBase);
    a: PieChartBase;
    a1(): void;
    bb(): void;
    ax(): void;
    a0(): void;
    bs: Brush;
    b: PieChartStyleInfo;
    protected h: RenderingContext;
    protected j: RenderingContext;
    protected i: RenderingContext;
    protected k: RenderingContext;
    c: PieChartViewManager;
    ay(a: any): void;
    b0(): Rect;
    bx(): Point;
    ba(): void;
    b2: Rect;
    private l;
    av(): void;
    private bi;
    private bz;
    protected a5(): void;
    protected a6(): void;
    private a8;
    private a9;
    private a7;
    private m;
    aj(a: Point, b: boolean, c: boolean): void;
    ai(a: Point): void;
    ah(a: Point): void;
    ak(a: Point): void;
    private ap;
    protected f: Slice;
    private bj;
    n(a: Point): boolean;
    p(a: Point): boolean;
    o(a: Point): boolean;
    private bd;
    al(): void;
    bn(a: any, b: any): void;
    protected u: List$1<Slice>;
    g(): Slice;
    be(a: Slice): void;
    bg(a: Slice): void;
    bf(a: Slice): void;
    protected t: List$1<PieLabel>;
    d(): PieLabel;
    ar(a: PieLabel): void;
    at(a: PieLabel): void;
    as(a: PieLabel): void;
    bl(a: PieLabel): void;
    bc(a: Slice): void;
    private bv;
    private bw;
    ad(a: Slice): any;
    y(a: any): number;
    bk(): void;
    v: number;
    x(a: any): number;
    b1(a: PieLabel): Rect;
    b3(): Size;
    bm(a: PieLabel, b: number, c: number): void;
    bp(a: any): void;
    br(): void;
    au(): void;
    private am;
    az(a: number, b: number): void;
    aw(): void;
    protected by: Point;
    protected ag: any;
    protected s: boolean;
    protected e: PieSliceDataContext;
    readonly af: any;
    aq(): void;
    bq(a: any): void;
    bo(a: Point, b: any, c: any): void;
    bh(): void;
    a2(): void;
    ac(): any;
    ao(): void;
    r(): boolean;
    an(a: PieChartVisualData): void;
    q(): boolean;
    a4(): void;
    bt(a: Slice): Brush;
    bu(a: Slice): Brush;
    w(a: Slice): number;
    z(a: Style): number;
    aa(): number;
    a3(): void;
    ae(a: any): any;
}
/**
 * @hidden
 */
export declare class PieSliceDataContext extends DataContext {
    static $t: Type;
    private _slice;
    slice: Slice;
    private _percentValue;
    percentValue: number;
    private _isOthersSlice;
    isOthersSlice: boolean;
    flatten(): any;
}
/**
 * @hidden
 */
export declare class SliceView extends Base {
    static $t: Type;
    protected a: Slice;
    constructor(a: Slice);
    g: Path;
    b(): void;
    c(): void;
    f(): Path;
    d(a: number, b: number): void;
    e(): void;
}
